<script setup>
import { onMounted } from 'vue';
import { useISAStore } from '@/stores/useISAStore'
const route = useRoute()
const ISAStore = useISAStore()
const dialog = ref(false)
const assay_to_delete = ref("")
const assayName = ref(null)
const showDataLinkWizard = ref(false)
const showImportWizard = ref(false)
const isaObject = ref(null)
const path = ref(null)
const depthDataObjects = ref(0)

onMounted(() => {
    assayName.value.focus()
})

// retrieve investigation data
if(ISAStore.investigations.size == 0) {
    await ISAStore.fetchInvestigations()
}
await ISAStore.fetchStudies(+route.params.iid)
await ISAStore.fetchAssays(+route.params.iid, +route.params.sid)

if(! await ISAStore.setCurrentAssay(+route.params.iid, +route.params.sid, +route.params.aid))
{
    // 404
}

function activateAssay() {
    ISAStore.currentAssay.status = 'active'
    saveCurrentAssay()
}

function saveCurrentAssay() {
    ISAStore.addUpdatedAssay(+route.params.iid, +route.params.sid, +route.params.aid)
}

async function deleteCurrentAssay() {
    await ISAStore.deleteCurrentAssay()
    dialog.value = false
    navigateTo('/investigations/i'+route.params.iid+'/studies/'+route.params.sid)
}

</script>

<template>
    <ImportWizard v-model="showImportWizard" :isaObject="ISAStore.currentAssay" :investigationId="Number(route.params.iid)" :studyId="Number(route.params.sid)"/>
    <v-dialog
      v-model="dialog"
      width="500"
    >
      <v-card>
        <v-card-title>Do you really want to delete this assay ?</v-card-title>
        <v-card-text>
            <p>By deleting this assay all the associated data links will be deleted.</p>

            <div v-if="ISAStore.currentAssay.name">
                <p class="mt-2">To confirm, type the name of the assay :</p>
                <v-text-field
                            label="Assay name"
                            variant="solo"
                            v-model="assay_to_delete"
                ></v-text-field>
            </div>
        </v-card-text>
        <v-card-actions>
            <v-btn @click="dialog = false">Cancel</v-btn>
            <v-btn color="error" @click="deleteCurrentAssay()" :disabled="assay_to_delete != ISAStore.currentAssay.name && ISAStore.currentAssay.name">Delete the assay</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <div class="pa-1 d-flex flex-row">
        <v-breadcrumbs class="pa-0" divider="/">
            <v-breadcrumbs-item :title="ISAStore.investigations.get(+$route.params.iid).name ? ISAStore.investigations.get(+$route.params.iid).name : 'No name'"></v-breadcrumbs-item>
            <v-breadcrumbs-item :title="ISAStore.investigations.get(+$route.params.iid).studies.get(+$route.params.sid).name ? ISAStore.investigations.get(+$route.params.iid).studies.get(+$route.params.sid).name : 'No name'"></v-breadcrumbs-item>
            <v-breadcrumbs-item :title="ISAStore.currentAssay.name ? ISAStore.currentAssay.name : 'No name'" disabled></v-breadcrumbs-item>
        </v-breadcrumbs>
        <v-chip class="mr-auto ma-2" size="small">
            <span v-if="ISAStore.hasPendingModification">Saving...</span>
            <span v-if="! ISAStore.hasPendingModification">Everything saved</span>
        </v-chip>
        <div>
            <v-menu>
                <template v-slot:activator="{ props }">
                    <v-btn icon="mdi-dots-horizontal" variant="plain" size="small" v-bind="props"></v-btn>
                </template>
                <v-list density="compact">
                    <v-list-item title="Delete" @click="assay_to_delete = ''; dialog = true">
                        <template v-slot:prepend>
                            <v-icon icon="mdi-trash-can-outline"></v-icon>
                        </template>
                    </v-list-item>
                </v-list>
            </v-menu>
        </div>
    </div>

    <div class="pa-4 pt-0">

        <h1>
            <v-text-field
                ref="assayName"
                v-model="ISAStore.currentAssay.name"
                placeholder="No name"
                variant="plain"
                prepend-inner-icon="mdi-test-tube"
                class="isa_name"
                @update:model-value="saveCurrentAssay()">
            </v-text-field>
        </h1>
        <small class="pa-0">Assay</small>

        <div v-if="ISAStore.currentAssay.status == 'pending'">
            <div class="mt-4">Choose how to create this assay...</div>
            <v-list class="pa-0" density="compact">
                <v-list-item class="pa-0"><v-btn color="primary" size="small" class="mt-2" @click="activateAssay()">Empty assay</v-btn></v-list-item>
                <v-list-item class="pa-0"><v-btn color="primary" size="small" class="mt-2" @click="showImportWizard = true">Import from ...</v-btn></v-list-item>
            </v-list>
        </div>

        <v-row v-if="ISAStore.currentAssay.status != 'pending'">
            <v-col>
                <v-textarea
                v-model="ISAStore.currentAssay.description"
                placeholder="No description"
                variant="plain"
                rows="1"
                auto-grow
                @update:model-value="saveCurrentAssay()"
                ></v-textarea>

                <DataLinkList :isaObject="ISAStore.currentAssay" :investigationId="Number(route.params.iid)" :studyId="Number(route.params.sid)"/>
            </v-col>

            <v-divider
                    class="mx-4"
                    vertical
                >
            </v-divider>
            <v-col cols="3">
                <h2>Data distribution</h2>
            </v-col>
        </v-row>
    </div>
</template>
